vfSetGetSettingsXml = {};

function vfSetGetSettingsXml:loadConfig()
	vfSetGet:setAcceptTxtColor();
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(VehicleFruitHud.settingsDir);
	local file = VehicleFruitHud.settingsDir.. "vehicleFruitHudSettings.xml";
	if not fileExists(file) then
		vfSetGetSettingsXml:saveConfig();
		VehicleFruitHud.values.firstStartVersion = true;
	else
		local Xml = loadXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
		local groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);		
		if getXMLBool(Xml, groupNameTag.. "#isOn") ~= nil then VehicleFruitHud.values.isOn = getXMLBool(Xml, groupNameTag.. "#isOn");end;
		if getXMLBool(Xml, groupNameTag.. "#viewBestPrice") ~= nil then VehicleFruitHud.values.viewBestPrice.isOn = getXMLBool(Xml, groupNameTag.. "#viewBestPrice");end;
		if getXMLBool(Xml, groupNameTag.. "#viewHorseHud") ~= nil then VehicleFruitHud.values.viewHorseHud = getXMLBool(Xml, groupNameTag.. "#viewHorseHud");end;	
		if getXMLBool(Xml, groupNameTag.. "#viewFillLimit") ~= nil then VehicleFruitHud.values.viewFillLimit = getXMLBool(Xml, groupNameTag.. "#viewFillLimit");end;
		if getXMLInt(Xml, groupNameTag.. "#fillLevelHudDistance") ~= nil then 
			local distance = getXMLInt(Xml, groupNameTag.. "#fillLevelHudDistance");
			if (distance >=30 or distance <=55) and ditstance ~= 35 then 
				FillLevelsDisplay.SIZE.BACKGROUND[2] = distance;
				FillLevelsDisplay.SIZE.FILL_TYPE_FRAME[2] = FillLevelsDisplay.SIZE.BACKGROUND[2];
				g_currentMission.hud.fillLevelsDisplay:storeScaledValues();
			end;
		end;
		if getXMLInt(Xml, groupNameTag.. "#difFillIconWidth") ~= nil then VehicleFruitHud.values.difFillIconWidth = getXMLInt(Xml, groupNameTag.. "#difFillIconWidth");end;
		if VehicleFruitHud.values.difFillIconWidth < 0 or VehicleFruitHud.values.difFillIconWidth > 3 then VehicleFruitHud.values.difFillIconWidth = 0;end;
		--if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then VehicleFruitHud.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;
		
		groupNameTag = ("vehicleFruitHudSettings.separator(%d)"):format(0);
		if getXMLString(Xml, groupNameTag.. "#fillTypeName") ~= nil then VehicleFruitHud.values.separator.fillTypeName = getXMLString(Xml, groupNameTag.. "#fillTypeName");end;
		if getXMLString(Xml, groupNameTag.. "#bestPrice") ~= nil then VehicleFruitHud.values.separator.bestPrice = getXMLString(Xml, groupNameTag.. "#bestPrice");end;
		if getXMLString(Xml, groupNameTag.. "#fillLevel") ~= nil then VehicleFruitHud.values.separator.fillLevel = getXMLString(Xml, groupNameTag.. "#fillLevel");end;
		if getXMLString(Xml, groupNameTag.. "#prozent") ~= nil then VehicleFruitHud.values.separator.prozent = getXMLString(Xml, groupNameTag.. "#prozent");end;
		if getXMLString(Xml, groupNameTag.. "#capacity") ~= nil then VehicleFruitHud.values.separator.capacity = getXMLString(Xml, groupNameTag.. "#capacity");end;
		
		local tempViewLine = {[1]={[1]={},[2]={},[3]={},[4]={},[5]={}},[2]={[1]={},[2]={},[3]={},[4]={},[5]={}},[3]={[1]={},[2]={},[3]={},[4]={},[5]={}}};
		for line=1, 3 do
			groupNameTag = ("vehicleFruitHudSettings.line".. tostring(line).. "(%d)"):format(0);
			if groupNameTag == nil or getXMLInt(Xml, groupNameTag.. "#difTxtSize") == nil then vfSetGetSettingsXml:saveConfig();VehicleFruitHud.values.firstStartVersion = true;break;end;
			if getXMLInt(Xml, groupNameTag.. "#difTxtSize") ~= nil then VehicleFruitHud.values.line[line].difTxtSize = getXMLInt(Xml, groupNameTag.. "#difTxtSize");end;
			if VehicleFruitHud.values.line[line].difTxtSize > VehicleFruitHud.values.minMaxDif.difTxtSize[1] or VehicleFruitHud.values.line[line].difTxtSize < VehicleFruitHud.values.minMaxDif.difTxtSize[2] then VehicleFruitHud.values.line[line].difTxtSize = 0;end;
			if getXMLInt(Xml, groupNameTag.. "#difHeight") ~= nil then VehicleFruitHud.values.line[line].difHeight = getXMLInt(Xml, groupNameTag.. "#difHeight");end;
			if VehicleFruitHud.values.line[line].difHeight > VehicleFruitHud.values.minMaxDif.difHeight[1] or VehicleFruitHud.values.line[line].difHeight < VehicleFruitHud.values.minMaxDif.difHeight[2] then VehicleFruitHud.values.line[line].difHeight = 0;end;
			if getXMLInt(Xml, groupNameTag.. "#difAlignment") ~= nil then VehicleFruitHud.values.line[line].difAlignment = getXMLInt(Xml, groupNameTag.. "#difAlignment");end;
			if VehicleFruitHud.values.line[line].difAlignment > VehicleFruitHud.values.minMaxDif.difAlignment[1] or VehicleFruitHud.values.line[line].difAlignment < VehicleFruitHud.values.minMaxDif.difAlignment[2] then VehicleFruitHud.values.line[line].difAlignment = 0;end;
			
			if getXMLInt(Xml, groupNameTag.. "#lsTxtAlignment") ~= nil then VehicleFruitHud.values.line[line].lsTxtAlignment = getXMLInt(Xml, groupNameTag.. "#lsTxtAlignment");end;
			if VehicleFruitHud.values.line[line].lsTxtAlignment > 3 or VehicleFruitHud.values.line[line].lsTxtAlignment < 0 then VehicleFruitHud.values.line[line].lsTxtAlignment = 3;end;
			
			if getXMLBool(Xml, groupNameTag.. "#txtBold") ~= nil then VehicleFruitHud.values.line[line].txtBold = getXMLBool(Xml, groupNameTag.. "#txtBold");end;
			if getXMLString(Xml, groupNameTag.. "#txtColor") ~= nil then VehicleFruitHud.values.line[line].txtColor = getXMLString(Xml, groupNameTag.. "#txtColor");end;
			if VehicleFruitHud.values.acceptTxtColor[VehicleFruitHud.values.line[line].txtColor] == nil then VehicleFruitHud.values.line[line].txtColor = VehicleFruitHud.values.txtColor;end;
			for pos=1, 5 do
				local posGroupNameTag = (groupNameTag.. ".pos".. tostring(pos).. "(%d)"):format(0);
				if getXMLString(Xml, posGroupNameTag.. "#name") ~= nil then 
					--tempViewLine[line][pos][1] = getXMLString(Xml, posGroupNameTag.. "#name");
					table.insert(tempViewLine[line][pos], getXMLString(Xml, posGroupNameTag.. "#name"));
				end;
				if getXMLBool(Xml, posGroupNameTag.. "#view") ~= nil then 
					--tempViewLine[line][pos][2] = getXMLBool(Xml, posGroupNameTag.. "#view");
					table.insert(tempViewLine[line][pos], getXMLBool(Xml, posGroupNameTag.. "#view"));
				end;
				VehicleFruitHud.values.viewLine[line] = tempViewLine[line];
			end;			
		end;		
	end;	
	if VehicleFruitHud.values.viewHorseHud then vfSetGet:generateDisplay();end;
end;

function vfSetGetSettingsXml:saveConfig()
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(VehicleFruitHud.settingsDir);
	local file = VehicleFruitHud.settingsDir.. "vehicleFruitHudSettings.xml";	
	local Xml = createXMLFile("VehicleFruitHud_XML", file, "vehicleFruitHudSettings");
	local groupNameTag = ("vehicleFruitHudSettings.info(%d)"):format(0);
	setXMLString(Xml, groupNameTag.."#WARNING", "NOT EDIT THIS XML OR VF CAN CRASH. EDIT ONLY SEPARATOR VALUES (notes space/accepted)");
	
	groupNameTag = ("vehicleFruitHudSettings.global(%d)"):format(0);		
	setXMLBool(Xml, groupNameTag.. "#isOn", VehicleFruitHud.values.isOn);
	setXMLBool(Xml, groupNameTag.. "#viewHorseHud", VehicleFruitHud.values.viewHorseHud);
	setXMLBool(Xml, groupNameTag.. "#hlDebugMode", VehicleFruitHud.hlDebugMode);		
	setXMLBool(Xml, groupNameTag.. "#viewBestPrice", VehicleFruitHud.values.viewBestPrice.isOn);
	setXMLBool(Xml, groupNameTag.. "#viewFillLimit", VehicleFruitHud.values.viewFillLimit);
	setXMLInt(Xml, groupNameTag.. "#fillLevelHudDistance", FillLevelsDisplay.SIZE.BACKGROUND[2]);
	setXMLInt(Xml, groupNameTag.. "#difFillIconWidth", VehicleFruitHud.values.difFillIconWidth);
	
	groupNameTag = ("vehicleFruitHudSettings.separator(%d)"):format(0);
	setXMLString(Xml, groupNameTag.. "#fillTypeName", VehicleFruitHud.values.separator.fillTypeName);
	setXMLString(Xml, groupNameTag.. "#fillLevel", VehicleFruitHud.values.separator.fillLevel);
	setXMLString(Xml, groupNameTag.. "#prozent", VehicleFruitHud.values.separator.prozent);
	setXMLString(Xml, groupNameTag.. "#capacity", VehicleFruitHud.values.separator.capacity);
	setXMLString(Xml, groupNameTag.. "#bestPrice", VehicleFruitHud.values.separator.bestPrice);
	
	for line=1, 3 do
		groupNameTag = ("vehicleFruitHudSettings.line".. tostring(line).. "(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#difTxtSize", VehicleFruitHud.values.line[line].difTxtSize);
		setXMLInt(Xml, groupNameTag.. "#difHeight", VehicleFruitHud.values.line[line].difHeight);
		setXMLInt(Xml, groupNameTag.. "#difAlignment", VehicleFruitHud.values.line[line].difAlignment);
		setXMLInt(Xml, groupNameTag.. "#lsTxtAlignment", VehicleFruitHud.values.line[line].lsTxtAlignment);
		setXMLBool(Xml, groupNameTag.. "#txtBold", VehicleFruitHud.values.line[line].txtBold);
		setXMLString(Xml, groupNameTag.. "#txtColor", VehicleFruitHud.values.line[line].txtColor);
		for pos=1, 5 do
			local posGroupNameTag = (groupNameTag.. ".pos".. tostring(pos).. "(%d)"):format(0);
			setXMLString(Xml, posGroupNameTag.. "#name", VehicleFruitHud.values.viewLine[line][pos][1]);
			setXMLBool(Xml, posGroupNameTag.. "#view", VehicleFruitHud.values.viewLine[line][pos][2]);
		end;
	end;	
	saveXMLFile(Xml);
end;

function vfSetGet:setAcceptTxtColor()
	for key, value in pairs (g_currentMission.hl.colorIntern) do
		if value[4] >= 1.00 and not string.find(key, "pulldown") then
			VehicleFruitHud.values.acceptTxtColor[key] = tostring(key);
		end;
	end;		
end;

function vfSetGetSettingsXml:onCloseCallbackGuiMenue()
	
end;

function vfSetGetSettingsXml:onOpenCallbackGuiMenue()

end;

function vfSetGetSettingsXml:onSaveCallbackGuiMenue()
	VehicleFruitHud:saveSettings();
end;
